package io.zipcoder;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;

import java.util.*;

import static java.util.Map.Entry.comparingByValue;
import static java.util.stream.Collectors.toList;

public  class WC {

    private Iterator<String> si;

    public  WC(String fileName) {
        try {
            Scanner scanner = new Scanner(new FileReader(fileName));
            scanner.useDelimiter("[\\p{Punct}\\s]+");
            this.si = scanner;
        } catch (FileNotFoundException e) {
            System.out.println(fileName + " Does Not Exist");
            System.exit(-1);
        }

    }

    public WC(Iterator<String> si) {

        this.si = si;
    }

    public void addcount() {
        Map<String, Integer> map = new HashMap<>();
        String[] splitted = si.toString().split("");
        for (int i = 0; i < splitted.length; i++) {
            if (map.containsKey(splitted[i])) {
                int cont = map.get(splitted[i]);
                map.put(splitted[i], cont + 1);
            } else {
                map.put(splitted[i], 1);
            }

        }
    }
      public Map <String,Integer >   sortMap()
        {
            Map<String, Integer> map = new HashMap<>();

        List<Map.Entry<String, Integer>> sorted = map
                .entrySet()
                .stream()
                .sorted(comparingByValue((e1, e2) -> e2 - e1))
                .collect(toList());
        return map;
    }
}
